clear all
loadlibrary('dynamixel','dynamixel.h');
libfunctions('dynamixel');

DEFAULT_PORTNUM = 3; %Puerto de entrada
DEFAULT_BAUDNUM = 1; 

%res = calllib('dynamixel','dxl_initialize'); %ver dxl_initialize en dynmixel.c
res=calllib('dynamixel', 'dxl_initialize', DEFAULT_PORTNUM, DEFAULT_BAUDNUM);

if res == 1
    for j=1:1:3

        disp('Succeed to open USB2Dynamixel!');

        calllib('dynamixel','dxl_write_word', 254, 34, 200); %par inicial de todos los motores

        %posiciones iniciales de todos los motores
        Present_Pos1=512;
        Present_Pos2=512;
        Present_Pos3=512;

        ID1 = 1; %identificador de del motor
        calllib('dynamixel','dxl_write_word', ID1, 32, 100); %velocidad
        calllib('dynamixel','dxl_write_word', ID1, 30, 256); %posicion

        ID2 = 6;                        
        calllib('dynamixel','dxl_write_word', ID2, 32, 100);
        calllib('dynamixel','dxl_write_word', ID2, 30, 256);

        ID3 = 2;
        calllib('dynamixel','dxl_write_word', ID3, 32, 100);
        calllib('dynamixel','dxl_write_word', ID3, 30, 0);

        while (Present_Pos1 > 256 && Present_Pos2 > 256) | Present_Pos3 > 0

            [flag, valores]=LecturaIR(1,1); %Lectura de los parametros del sensor

            if valores(1) > 30 | valores(2) > 30 | valores(3) > 30

                calllib('dynamixel','dxl_write_word', 254, 34, 1); %cambio del par de los motores

                Present_Pos1 = int32(calllib('dynamixel','dxl_read_word',ID1,36)); %lectura de la posicion actual del motor 1
                calllib('dynamixel','dxl_write_word', ID1, 30, Present_Pos1); %obliga a detener el motor 1 en su posicion actual

                Present_Pos2 = int32(calllib('dynamixel','dxl_read_word',ID2,36))
                calllib('dynamixel','dxl_write_word', ID2, 30, Present_Pos2);

                Present_Pos3 = int32(calllib('dynamixel','dxl_read_word',ID3,36));
                calllib('dynamixel','dxl_write_word', ID3, 30, Present_Pos3);

                return
            end

            Present_Pos1 = int32(calllib('dynamixel','dxl_read_word',ID1,36));
            Present_Pos2 = int32(calllib('dynamixel','dxl_read_word',ID2,36));
            Present_Pos3 = int32(calllib('dynamixel','dxl_read_word',ID3,36));

        end
        pause(1.5); %pausa para ejecutar las instrucciones de movimiento

        %RETORNO

        calllib('dynamixel','dxl_write_word', ID1, 32, 100);
        calllib('dynamixel','dxl_write_word', ID1, 30, 512);

        calllib('dynamixel','dxl_write_word', ID2, 32, 100);
        calllib('dynamixel','dxl_write_word', ID2, 30, 512);
                                
        calllib('dynamixel','dxl_write_word', ID3, 32, 100);
        calllib('dynamixel','dxl_write_word', ID3, 30, 512);

        Present_Pos1=0;
        Present_Pos2=0;
        Present_Pos3=0;
    
        while (Present_Pos1 < 511 && Present_Pos2 < 511) | Present_Pos3 < 511

            [flag, valores]=LecturaIR(1,1) %Lectura del sensor

            if valores(1) > 30 | valores(2) > 30 | valores(3) > 30

                calllib('dynamixel','dxl_write_word', 254, 34, 1); %cambio del par de los motores

                Present_Pos1 = int32(calllib('dynamixel','dxl_read_word',ID1,36)); %Lectura de la posicion inicial
                calllib('dynamixel','dxl_write_word', ID1, 30, Present_Pos1);

                Present_Pos2 = int32(calllib('dynamixel','dxl_read_word',ID2,36));
                calllib('dynamixel','dxl_write_word', ID2, 30, Present_Pos2);

                Present_Pos3 = int32(calllib('dynamixel','dxl_read_word',ID3,36));
                calllib('dynamixel','dxl_write_word', ID3, 30, Present_Pos3);

                return
            end

            Present_Pos1 = int32(calllib('dynamixel','dxl_read_word',ID1,36));
            Present_Pos2 = int32(calllib('dynamixel','dxl_read_word',ID2,36));
            Present_Pos3 = int32(calllib('dynamixel','dxl_read_word',ID3,36));

        end

        calllib('dynamixel','dxl_write_word', 254, 34, 200);

        pause(1.5);

    end

    calllib('dynamixel','dxl_terminate');

else
    disp('Failed to open USB2Dynamixel!');
    unloadlibrary('dynamixel');

    return
end


unloadlibrary('dynamixel');
